Slider = class:new();

function Slider:init(maxvalue, minvalue, x, width)
	self.maxvalue = maxvalue
	self.y = minvalue
	self.width = width
	self.height = 0
	self.x = x
	self.DrawX = x
	self.minvalue = minvalue
	self:SetHeight()
	self.NeedDrag = false
	self.Value = self.y - minvalue
end

function Slider:Update(dt)
	if ((love.mouse.getX() >= self.x) and 
		(love.mouse.getX() <= self.x + self.width)) 
	then
		if self.DrawX - 3 > self.x
		then
			self.DrawX = self.DrawX - 1
		end
	else
		if self.width + self.x - self.DrawX > 0 and not self.NeedDrag
		then
			self.DrawX = self.DrawX + 1
		end
	end
end

function Slider:SetHeight()
	self.height = 10
end

function Slider:SetMaxValue(Maxvalue)
	self.maxvalue = Maxvalue
end

function Slider:Contains(mousex)
	if ((mousex >= self.x) and 
		(mousex <= self.x + self.width)) 
	then
		self.NeedDrag = true
		return true
	else
		return false
	end
end

function Slider:Drag(mousey)
	self.y = mousey - self.height / 2
	if (self.y > self.maxvalue) then
		self.y = self.maxvalue
	end
	
	if (self.y < self.minvalue) then
		self.y = self.minvalue
	end
end

function Slider:Draw(image)
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(image, self.DrawX, self.y)
end
