TextBox = class:new();

function TextBox:init(x, y, Height)
	require "Slider"
	self.Slider = Slider
	self.Slider:init(590, 10, 390, 10)
	self.SliderImage = love.graphics.newImage("slider.png")
	self.StartDrawingString = 0
	self.x = x
	self.y = y
	self.Width = Width
	self.strings = {""}
	self.Size = 1
	self.UsingString = 1
	self.MaxUsingChar = self.UsingChar
	self.UsingChar = 0
end

function TextBox:PrintString(str, x, y, UsingChar)
	local TabsCount = 0
	for i = 1, string.len(str) do
		if string.char(9) == string.sub(str, i, i)
		then
			love.graphics.print("    ", x + i * 10, y)
			--print(string.sub(str, i, i + 1))
			TabsCount = TabsCount + 1
		else
			if string.sub(str, i, i + 1) == "do" or
				string.sub(str, i - 1, i) == "do"
			then
				love.graphics.setColor(0, 0, 255)
			end
			love.graphics.print(string.sub(str, i, i), x + i * 10 + TabsCount * 30, y)
			love.graphics.setColor(0, 0, 0)
		end
		if UsingChar == i
		then
			love.graphics.setColor(127, 127, 127)
			love.graphics.print("|",x + (i + 1) * 10 - 2 + TabsCount * 30, y - 2)
			love.graphics.setColor(0, 0, 0)
		end	
	end
	if UsingChar == 0
	then
		love.graphics.setColor(127, 127, 127)
		love.graphics.print("|", x + 8, y - 2)
		love.graphics.setColor(0, 0, 0)
	end
end

function TextBox:Update(dt)
	if ((love.mouse.isDown('l') and 
		self.Slider:Contains(love.mouse.getX())) or
		self.Slider.NeedDrag) then
			self.Slider:Drag(love.mouse.getY())
	end
end

function TextBox:MouseReleased(x, y, button)
	self.Slider.NeedDrag = false
end

function TextBox:Draw() -- Drawing
	love.graphics.setColor(0, 0, 0)
	for i = 1, self.Size do
		love.graphics.print(i, self.x - 8, self.y + i * 11 - 1)
		love.graphics.print("|", self.x + 20, self.y + i * 11 - 1)
		if self.UsingString == i then
			TextBox:PrintString(self.strings[self.UsingString], self.x + 20, i * 11 - 1, self.UsingChar)
		else
			TextBox:PrintString(self.strings[i], self.x + 20, i * 11 - 1, -1)
		end
	end
	self.Slider:Draw(self.SliderImage)
	love.graphics.setColor(255, 255, 255)
end

function TextBox:keypressed(key, unicode)

	if unicode > 31 and unicode < 127 or unicode == 9
	then
		self.strings[self.UsingString] = 
			string.sub(self.strings[self.UsingString], 
			1, self.UsingChar + 1) .. string.char(unicode) ..
			string.sub(self.strings[self.UsingString], self.UsingChar + 2, -1)
		self.UsingChar = self.UsingChar + 1
		self.MaxUsingChar = self.UsingChar
	end

	--print((unicode))

	if key == 'delete' --it will delete char 
	then
		if self.UsingChar == string.len(self.strings[self.UsingString])
		then
			if self.Size > self.UsingString
			then
				self.strings[self.UsingString] = self.strings[self.UsingString] ..
					self.strings[self.UsingString + 1]
				table.remove(self.strings, self.UsingString + 1)
				self.Size = self.Size - 1
			end
		else
			self.strings[self.UsingString] = 
				string.sub(self.strings[self.UsingString], 
				1, self.UsingChar) .. 
				string.sub(self.strings[self.UsingString], self.UsingChar + 2, -1)
		end
		self.MaxUsingChar = self.UsingChar
	end
	
	if key == 'backspace' --it will delete char 
	then
		if self.UsingChar > 0
		then
			self.strings[self.UsingString] = 

				string.sub(self.strings[self.UsingString], 
				1, self.UsingChar - 1) .. string.sub(self.strings[self.UsingString], 
				self.UsingChar + 1, string.len(self.strings[self.UsingString]))
			self.UsingChar = self.UsingChar - 1
		else
			if self.Size > 1
			then
			self.UsingChar = string.len(self.strings[self.UsingString - 1])
			self.strings[self.UsingString - 1] = 
				self.strings[self.UsingString - 1] ..
				self.strings[self.UsingString]
				table.remove(self.strings, self.UsingString)
				self.Size = self.Size - 1
			else
				UsingChar = 0
			end
		end
		self.MaxUsingChar = self.UsingChar
	end

	if key == 'left' --it will move cursor left
	then
		self.UsingChar = self.UsingChar - 1
        if self.UsingChar < 0
		then
			if self.UsingString > 1
			then
				self.UsingString = self.UsingString - 1
				self.UsingChar = string.len(self.strings[self.UsingString])
			else
				self.UsingChar = string.len(self.strings[self.UsingString])
			end
		end
		self.MaxUsingChar = self.UsingChar
	end

	if key == 'right' --it will move cursor right
	then
		self.UsingChar = self.UsingChar + 1
		if self.UsingChar > string.len(self.strings[self.UsingString])
		then
			self.UsingString = self.UsingString + 1
			self.UsingChar = 0
		end
		self.MaxUsingChar = self.UsingChar
	end

	if key == 'up'
	then
		if self.UsingString > 1
		then
			self.UsingString = self.UsingString - 1
			if self.UsingString > self.Size
			then
				self.UsingString = self.Size
			end
			self.UsingChar = self.MaxUsingChar
		else
			self.UsingString = self.Size
		end
	end

	if key == 'down'
	then
		self.UsingString = self.UsingString + 1
		if self.UsingString > self.Size
		then
			self.UsingString = 1
		end
		self.UsingChar = self.MaxUsingChar
	end
	
	if key == 'return' --It add new string
	then
		if self.UsingChar == string.len(self.strings[self.UsingString])
		then
			local s = ""
			local spaceTab = true
			local i = 1
			while spaceTab do
				if string.sub(self.strings[self.UsingString], i, i) == " " or
					string.sub(self.strings[self.UsingString], i, i) == string.char(9)
				then
					s = s .. string.sub(self.strings[self.UsingString], i, i)
					i = i + 1
				else
					spaceTab = false
				end
			end
			self.Size = self.Size + 1
			table.insert(self.strings, self.UsingString + 1, s)
			self.UsingString = self.UsingString + 1
		else
			self.Size = self.Size + 1
			table.insert(self.strings, self.UsingString + 1,
				string.sub(self.strings[self.UsingString], self.UsingChar + 1, -1))
			self.strings[self.UsingString] = 
			string.sub(self.strings[self.UsingString], 1, self.UsingChar)
			self.UsingString = self.UsingString + 1
			self.UsingChar = 0
		end
	end

	--Errors deleting zone start
	if self.UsingString > self.Size
	then
		self.UsingString = self.Size
	end

	if self.UsingString < 1
	then
		self.UsingString = 1
	end

	if self.UsingChar > string.len(self.strings[self.UsingString])
	then
		self.UsingChar = string.len(self.strings[self.UsingString])
	end

	--Errors deleting zone finished

--	--debugging starting
--	local l = ""
--	for i = 1, string.len(self.strings[self.UsingString]) do
--		l = l .. i
--	end
--	print(self.UsingString)
--	print(l)
--	print(self.strings[self.UsingString])
--	print(self.UsingChar)
--	--debuging finished
end --If you not me: thanks for downloading ;)
